#	$Id: Canvas2OODraw.tcl 229 2007-11-17 16:07:40Z grosserw $

package require Itcl
package require Tk

itcl::class itcluno::Canvas2OODraw {
#	draw a line with length e.g. 30c
#	get the coords and calculate expr 30/(<xcoordEnd>-<xccordStart>)
	common convFactor 2.921875
	proc standardOptions {config {confOptions ""}} {
		array set options $confOptions
	
	#	unused common configuration
	#		-activedash -
	#		-disableddash -
	#		-activefill -
	#		-disabledfill -
	#		-activeoutline -
	#		-disabledoutline -
	#		-activeoutlinestipple -
	#		-disabledoutlinestipple -
	#		-activestipple -
	#		-disabledstipple -
	#		-activewidth -
	#		-disabledwidth {
	#		}
	#		-state -
	#		-tags {
	#		}
	
		foreach conf $config {
			switch -- [lindex $conf 0] {
				-dash {
				}
				-dashoffset {
				}
				-fill {
					if {[string length [lindex $conf end]] == 0} {
						lappend configList FillTransparence 100
					} else {
						eval lappend configList [itcluno::OfficeUtilities::tkColor2ooColor $options([lindex $conf 0]) [lindex $conf end]]
					}
				}
				-offset {
				}
				-outline {
					if {[string length [lindex $conf end]] == 0} continue
					eval lappend configList [itcluno::OfficeUtilities::tkColor2ooColor LineColor [lindex $conf end]]
				}
				-stipple {
				}
				-width {
					lappend configList LineWidth [expr {int([lindex $conf end]*$convFactor*10)}]
				}
			}
		}
		return  $configList
	}
	proc createLine {document page offset coordList config} {
		set x1 [lindex $coordList 0]
		set y1 [lindex $coordList 1]
		set shapeList [list]
		set arrowConf none
		set configList [list]
		eval lappend configList [standardOptions $config [list -fill LineColor]]
		array set configArray $configList
		set capConf Circle
		foreach conf $config {
			switch -- [lindex $conf 0] {
				-arrow {
					set arrowConf [lindex $conf end]
					set arrowWidth [expr {$configArray(LineWidth)+300}]
				}
				-arrowshape {
				}
				-capstyle {
					switch [lindex $conf end] {
						butt {
							set capConf BEVEL
						}
						projecting {
							set capConf MITER
						}
						round {
							set capConf Circle
						}
					}
				}
				-joinstyle {
					switch [lindex $conf end] {
						bevel {
							set joinStyle BEVEL
						}
						miter {
							set joinStyle MITER
						}
						round {
							set joinStyle ROUND
						}
					}
					lappend configList LineJoint [itcluno::OfficeUtilities::enum com.sun.star.drawing.LineJoint $joinStyle]
				}
				-smooth {
				}
				-splinesteps {
				}
			}
		}
	#	if {[llength $coordList] > 5} {
	#		puts stderr [subst -nocommands {set shapeList [$document createShape $page $coordList PolyLine $configList]}]
	#		set shapeList [$document createShape $page $coordList PolyLine $configList]
	#	} else {
	#		set shapeList [$document createShape $page $coordList Line $configList]
	#	}
		foreach {x2 y2} [lrange $coordList 2 end-1] {
			set coords [list]
			lappend coords \
				[expr {$x1+[lindex $offset 0]}] [expr {$y1+[lindex $offset 1]}]
			lappend coords [expr {$x2-$x1}] [expr {$y2-$y1}] [lindex $coordList end]
			lappend configList FillTransparence 100
	#		puts stderr "$document createShape $page $coords Line $configList"
			set tmp [$document createShape $page $coords Line $configList]
			if {[string length $tmp] == 0} continue
			lappend shapeList $tmp
			set x1 $x2
			set y1 $y2
		}
		
		switch $capConf {
			Circle {
				foreach e $shapeList {
					$e setPropertyValue LineStartName $capConf
					$e setPropertyValue LineStartWidth $configArray(LineWidth)
					$e setPropertyValue LineEndName $capConf
					$e setPropertyValue LineEndWidth $configArray(LineWidth)
				}
			}
		}
	
		set standardArrow "Arrow concave"
		switch $arrowConf {
			first {
				[lindex $shapeList 0] setPropertyValue LineStartName $standardArrow
				[lindex $shapeList 0] setPropertyValue LineStartWidth $arrowWidth
			}
			last {
				[lindex $shapeList end] setPropertyValue LineEndName $standardArrow
				[lindex $shapeList 0] setPropertyValue LineEndWidth $arrowWidth
			}
			both {
				[lindex $shapeList 0] setPropertyValue LineStartName $standardArrow
				[lindex $shapeList 0] setPropertyValue LineStartWidth $arrowWidth
				[lindex $shapeList end] setPropertyValue LineEndName $standardArrow
				[lindex $shapeList 0] setPropertyValue LineEndWidth $arrowWidth
			}
		}
		return $shapeList
	}
	proc createPolygon {document page offset coordList config} {
		return [createLine $document $page $offset $coordList $config]
	}
	proc createText {document page offset coordList config} {
		set fontConvFactor 1; #.90
		set textString ""
		set coords [list]
		foreach {x1 y1 x2 y2 unit} $coordList break
		lappend coords \
			[expr {$x1+[lindex $offset 0]}] [expr {$y1+[lindex $offset 1]}] \
			[expr {($x2-$x1)*1.5}] [expr {$y2-$y1}] $unit
		set configList [list]
		set textConfigList [list]
		lappend configList TextLeftDistance 0
		lappend configList TextRightDistance 0
		lappend configList TextUpperDistance 0
		lappend configList TextLowerDistance 0
		foreach conf $config {
			switch -- [lindex $conf 0] {
				-anchor {
					set anchor [lindex $conf end]
					set horzAdjust LEFT
					set vertAdjust CENTER
					lappend configList TextHorizontalAdjust [itcluno::OfficeUtilities::enum com.sun.star.drawing.TextHorizontalAdjust $horzAdjust]
				}
				-font {
					foreach {name height weight} [lindex $conf end] break
					lappend textConfigList CharFontName $name CharHeight [expr {abs($height)*$fontConvFactor}]
				}
				-fill {
					eval lappend textConfigList [itcluno::OfficeUtilities::tkColor2ooColor CharColor [lindex $conf end]]
				}
				-justify {
					lappend textConfigList ParaAdjust [itcluno::OfficeUtilities::enum com.sun.star.style.ParagraphAdjust [string toupper [lindex $conf end]]]
				}
				-text {
					set textString [lindex $conf end]
				}
				-width {
					
				}
			}
		}
		set shape [$document createShape $page $coords Text $configList]
		set text [$shape getText]
		set textEnd [$text getEnd]
		foreach {name value} $textConfigList {
			$textEnd setPropertyValue $name $value
		}
		$text setString $textString
		return $shape
	}
	proc createRectangle {document page offset coordList config} {
		set coords [list]
		foreach {x1 y1 x2 y2 unit} $coordList break
		lappend coords \
			[expr {$x1+[lindex $offset 0]}] [expr {$y1+[lindex $offset 1]}] \
			[expr {$x2-$x1}] [expr {$y2-$y1}] $unit
		set configList [list]
		eval lappend configList [standardOptions $config [list -fill FillColor]]
		lappend configList LineJoint [itcluno::OfficeUtilities::enum com.sun.star.drawing.LineJoint MITER]
		foreach conf $config {
			switch -- [lindex $conf 0] {
				non-standardOptions {}
			}
		}
		return [$document createShape $page $coords Rectangle $configList]
	}
	proc createWindow {document page offset coordList config} {
		package require Img
		set coords [list]
		foreach {x1 y1 x2 y2 unit} $coordList break
		lappend coords \
			[expr {$x1+[lindex $offset 0]}] [expr {$y1+[lindex $offset 1]}] \
			[expr {$x2-$x1}] [expr {$y2-$y1}] $unit
		set configList [list]
		foreach conf $config {
			switch -- [lindex $conf 0] {
				-window {
					set image [image create photo -data [lindex $conf end]]
					$image write canvas2oodrawing.$image.png -format png
					lappend configList GraphicURL [itcluno::OfficeUtilities::filenameToURL canvas2oodrawing.$image.png]
				}
			}
		}
		return [$document createShape $page $coords GraphicObject $configList]
	}
	proc createArc {document page offset coordList config} {
		set coords [list]
		foreach {x1 y1 x2 y2 unit} $coordList break
		lappend coords \
			[expr {$x1+[lindex $offset 0]}] [expr {$y1+[lindex $offset 1]}] \
			[expr {$x2-$x1}] [expr {$y2-$y1}] $unit
		set startAngle 0
		set extentAngle 0
		set configList [list]
		eval lappend configList [standardOptions $config [list -fill FillColor]]
		foreach conf $config {
			switch -- [lindex $conf 0] {
				-start {
					set startAngle [lindex $conf end]
					lappend configList CircleStartAngle [expr {int($startAngle*100)}]
				}
				-extent {
					set extentAngle [lindex $conf end]
					lappend configList CircleEndAngle EXTENT_ANGLE
				}
				-style {
					switch [lindex $conf end] {
						chord {
							lappend configList CircleKind [itcluno::OfficeUtilities::enum com.sun.star.drawing.CircleKind CUT]
						}
						arc {
							lappend configList CircleKind [itcluno::OfficeUtilities::enum com.sun.star.drawing.CircleKind ARC]
						}
						default {
							lappend configList CircleKind [itcluno::OfficeUtilities::enum com.sun.star.drawing.CircleKind SECTION]
						}
					}
				}
			}
		}
	#	puts stderr $extentAngle
		if {$extentAngle == 0} {
			array set tmp $configList
			unset tmp(CircleKind)
			unset tmp(CircleStartAngle)
			unset tmp(CircleEndAngle)
			set configList [array get tmp]
			lappend configList CircleKind [itcluno::OfficeUtilities::enum com.sun.star.drawing.CircleKind FULL]
		} else {
			regsub EXTENT_ANGLE $configList [expr {int(($startAngle+$extentAngle)*100)}] configList
		}
	#	puts stderr "$document createShape $page $coords Ellipse $configList"
		return [$document createShape $page $coords Ellipse $configList]
	}
	proc createOval {document page offset coordList config} {
	#	lappend config [list -start 0] [list -extent 0] [list -style chord]
	#	puts stderr oval:$config:
	#	return [createArc $document $page $offset $coordList $config]
		set coords [list]
		foreach {x1 y1 x2 y2 unit} $coordList break
		lappend coords \
			[expr {$x1+[lindex $offset 0]}] [expr {$y1+[lindex $offset 1]}] \
			[expr {$x2-$x1}] [expr {$y2-$y1}] $unit
		set startAngle 0
		set extentAngle 0
		set configList [list]
		eval lappend configList [standardOptions $config [list -fill FillColor]]
		foreach conf $config {
			switch -- [lindex $conf 0] {
				non-standard_options {}
			}
		}
		lappend configList CircleKind [itcluno::OfficeUtilities::enum com.sun.star.drawing.CircleKind FULL]
	#	puts stderr "$document createShape $page $coords Ellipse $configList"
		return [$document createShape $page $coords Ellipse $configList]
	}
	proc createShape {document page offset w items item} {
	#	puts stderr $item:[$w type $item]:[$w coords $item]:[$w itemconfigure $item]
	#	puts stderr $item
		set coords [list]
		if {[llength $offset] == 0} {
			set offset [list 0 0]
		}
		if {[llength $offset] == 3} {
			set unit [lindex $offset end]
			set unitFactor [expr {[tcluno_soffice::getUnitFactor $unit]/double([tcluno_soffice::getUnitFactor cm])}]
			set tmp [list]
			for {set i 0} {$i < 2} {incr i} {
				lappend tmp [expr {[lindex $offset $i]*$unitFactor}]
			}
			set offset $tmp
		}
		switch [$w type $item] {
			window {
				foreach coord [$w bbox $item] {
					lappend coords [expr {$coord/100.0*$convFactor}]
				}
				set scrollregion [list]
				foreach coord [lrange [$w bbox $item] 0 1] {
					incr coord -10
					lappend scrollregion $coord
				}
				foreach coord [lrange [$w bbox $item] 2 3] {
					incr coord 10
					lappend scrollregion $coord
				}
				return
			}
			text {
				foreach coord [$w bbox $item] {
					lappend coords [expr {$coord/100.0*$convFactor}]
				}
			}
			default {
				foreach coord [$w coords $item] {
					lappend coords [expr {$coord/100.0*$convFactor}]
				}
			}
		}
		lappend coords cm
		switch [$w type $item] {
			polygon {
				#	we have to take care of the last element of coords: cm
				set coords [concat [lrange $coords 0 end-1] [lrange $coords 0 1] [lindex $coords end]]
			}
			window {
				set saveScrollregion [$w cget -scrollregion]
				$w configure -scrollregion $scrollregion
				set xview [$w xview]
				$w xview moveto 0
				set yview [$w yview]
				$w yview moveto 0
				update idletasks
			}
		}
		set shapes [create[string totitle [$w type $item]] $document $page $offset $coords [$w itemconfigure $item]]
	#	puts stderr [llength $shapes]:$shapes:
		if {[llength $shapes] > 1} {
			set itemIdx 0
			foreach shape $shapes {
				$shape setName "$page $items item [expr {$item+100}].$itemIdx"
				incr itemIdx
			}
	#		update
	#		set shapes [$document group $page $shapes "$page $items item $item"]
		} else {
			if {[string length $shapes] > 0} {
				$shapes setName "$page $items item [expr {$item+100}]"
			}
		}
		switch [$w type $item] {
			window {
				$w configure -scrollregion $saveScrollregion
				$w xview moveto [lindex $xview 0]
				$w yview moveto [lindex $yview 0]
				update idletasks
			}
		}
		return $shapes
	}
	proc Canvas2OODrawing {document page offset canvas {items all}} {
		set shapeList [list]
		set itemList [eval $canvas find $items]
		set maxItems 20
	#	puts stderr [tcluno_soffice::windowTitle [$document cget -desktop]]
		if {[llength $itemList] > $maxItems} {
			set itemList [lrange $itemList 0 $maxItems]
		}
		foreach item $itemList {
			set tmp [createShape $document $page $offset $canvas $items $item]
			if {[string length $tmp] == 0} continue
			lappend tmpList $tmp
		}
		for {set i 0} {$i < [llength $itemList]} {incr i $maxItems} {
			set tmpList [list]
			foreach item [lrange $itemList $i [expr {$i+$maxItems-1}]] {
				set tmp [createShape $document $page $offset $canvas $items $item]
				if {[string length $tmp] == 0} continue
				lappend tmpList $tmp
			}
	#		$document group $page $tmpList "$page $items $i-[expr {$i+$maxItems-1}]"
			eval lappend shapeList $tmpList
		}
	#	puts stderr "$document group $page $shapeList \"$page $items\""
	#	$document group $page $shapeList "$page $items"
	}
}
