#*************************************************************************
#*
#*  $RCSfile: RunExamples.tcl,v $
#*
#*  $Revision:188 $
#*
#*  last change: $Author: grosserw $ $Date: 2006-01-30 08:51:55 +0100 (Mo, 30 Jan 2006) $
#*
#*  The Contents of this file are made available subject to the terms of
#*  the following license
#*
#*  - BSD License
#*
#*  see file license.terms in this directory
#*
#*  Copyright 2005-2006 Wolfgang Grosser
#*
#*  Author: Wolfgang Grosser
#*
#*   All Rights Reserved.
#*
#*   Contributor(s): 
#*
#*
#************************************************************************/

encoding system utf-8

proc showDescription {w} {
	update idletasks
	set cmd [$w get]
	.text delete 1.0 end
	.text insert end "Short Description of\n\n$cmd\n" description
	set cmdDescr $::description($cmd)
	regsub -all {\\n} $cmdDescr "\n" cmdDescr 
	.text insert end $cmdDescr
}
proc runCommand {w} {
	set cmd [$w get]
	uplevel #0 $::example($cmd)
	puts stderr "example finished"
}
proc saveSource {top textW} {
	set out_filename [tk_getSaveFile -parent $top]
	if {[string length $out_filename] == 0} return
	set out_fd [open $out_filename w]
	puts $out_fd [$textW get 1.0 end]
	flush $out_fd
	close $out_fd
}
proc showCommand {w} {
	update idletasks
	set cmd [$w get]
	set top .source
	catch {destroy $top}
	toplevel $top
	wm title $top "Source of $cmd"
	ScrolledWindow $top.sw
	text $top.text
	$top.text insert end $::example($cmd)
	$top.sw setwidget $top.text
	set bFrame [frame $top.bFrame]
	button $bFrame.save -text Save -command [list saveSource $top $top.text]
	button $bFrame.dismiss -text Dismiss -command [list destroy $top]
	pack $top.sw -side top -expand 1 -fill both
	pack $top.bFrame -side top -fill x
	pack $bFrame.save -side left
	pack $bFrame.dismiss -side right
}

foreach file [list Presentation.tcl SpreadSheet.tcl Tablelist2OOTable.tcl Tktable2OOTable.tcl Writer.tcl] {
	source [file join [file dirname [info script]] $file]
}

package require BWidget

package require tclurtp
package require tcluno
package require itcluno 0.2

set OOoTopDir /usr/lib/ooo3

if {![file isdirectory $OOoTopDir]} {
	tk_messageBox \
		-title "Choose OOo top diretory" -type ok -icon info \
		-message "Choose OOo top directory\notherwise some examples do not run\nas you will expect"
	set OOoTopDir [tk_chooseDirectory \
		-title "Select OOo top directory (should contain a subdir named share" \
		-mustexist 1 \
	]
}

label .cbl -text "Select a command:"
ComboBox .cb -values [lsort [array names example]] \
	-modifycmd [list showDescription .cb]
.cb setvalue @0
grid .cbl -row 1 -column 0 -sticky w
grid .cb -row 1 -column 1 -sticky we
grid columnconfigure . 1 -weight 1
ScrolledWindow .sw
text .text -wrap word
set font [.text cget -font]
.text tag configure description -font $font
grid .sw -row 2 -column 0 -sticky wens -columnspan 2

grid rowconfigure . 2 -weight 1
.sw setwidget .text

button .showcmd -text "Source" \
	-command [list showCommand .cb]
grid .showcmd -row 3 -column 0
button .runcmd -text "Run" \
	-command [list runCommand .cb]
grid .runcmd -row 3 -column 1
showDescription .cb
