#*************************************************************************
#*
#*  $RCSfile$
#*
#*  $Id: bootstrap.tcl 210 2006-07-21 15:50:16Z grosserw $
#*
#*  last change: $Author: grosserw $ $Date: 2006-07-21 17:50:16 +0200 (Fr, 21. Jul 2006) $
#*
#*  The Contents of this file are made available subject to the terms of
#*  the following license
#*
#* 	- BSD License
#*
#*	see file license.terms in this directory
#*
#*  Copyright 2005 Arnulf Wiedemann
#*
#*  Author: Arnulf Wiedemann
#*
#*  Contributor(s): 
#*
#************************************************************************/

namespace eval ::tclUrtpBridge {

variable uno_types [list \
	VOID \
	CHAR \
	BOOLEAN \
	BYTE \
	SHORT \
	UNSIGNED_SHORT \
	LONG \
	UNSIGNED_LONG \
	HYPER \
	UNSIGNED_HYPER \
	FLOAT \
	DOUBLE \
	STRING \
	TYPE \
	ANY \
	ENUM \
	TYPEDEF \
	STRUCT \
	UNION \
	EXCEPTION \
	SEQUENCE \
	ARRAY \
	INTERFACE \
	SERVICE \
	MODULE \
	INTERFACE_METHOD \
	INTERFACE_ATTRIBUTE \
	UNKNOWN \
	PROPERTY \
	CONSTANT \
	CONSTANTS \
	SINGLETON \
]

variable bootstrap_method_return_types

# **************************** InitBootstrapVariables ******************

proc InitBootstrapVariables {} {
	variable data
	variable uno_types
	variable bootstrap_method_return_types

	set idx 0
	foreach type $uno_types {
		set data(typeclass,$type) $idx
		set data(typeclass,$idx) $type
		incr idx
	}
	set bootstrap_method_return_types(com.sun.star.uno.XInterface,queryInterface) any
	set bootstrap_method_return_types(com.sun.star.uno.XInterface,release) void
}

}
