#*************************************************************************
#*
#*  $RCSfile$
#*
#*  $Revision: 182 $
#*
#*  last change: $Author: grosserw $ $Date: 2006-01-27 17:57:57 +0100 (Fr, 27. Jan 2006) $
#*
#*  The Contents of this file are made available subject to the terms of
#*  the following license
#*
#* 	- BSD License
#*
#*	see file license.terms in this directory
#*
#*  Copyright 2005 Wolfgang Grosser
#*
#*  Author: Wolfgang Grosser
#*
#*  Contributor(s): 
#*
#************************************************************************/

set notFoundPage {
<html><title>Not Found</title><body>File %s not found</body></html>
}
proc goBack {} {
	set lastUrl [lindex $::visitedUrls end-1]
	set ::visitedUrls [lreplace $::visitedUrls end-1 end]
	showDocumentation $lastUrl
}
proc getHtmlTitle {w} {
	set titleStart [lindex [$::documentationTopLevel.html token find title] 0]
	set titleEnd [lindex [$::documentationTopLevel.html token getend $titleStart] 0]
	incr titleStart
	incr titleEnd -1
	return "Documentation: [$::documentationTopLevel.html text html $titleStart $titleEnd]"
}
proc getHtmlText {url} {
	if {![file exists $::urlRoot/$url]} {
		return [format $::notFoundPage $::urlRoot/$url]
	}
	set fd [open $::urlRoot/$url]
	set text [read -nonewline $fd]
	close $fd
	return $text
}
proc showDocumentation {{url ""}} {
	if {[string length $url] == 0} {
		set url $::rootDocument
	}
	if {![winfo exists $::documentationTopLevel]} {
		makeHtmlGui $::documentationTopLevel
	}
	wm deiconify $::documentationTopLevel
	raise $::documentationTopLevel
	if {[string first {#} $url] >= 0} {
		lappend ::visitedUrls $url
		set url [split $url {#}]
		set base [lindex $url 0]
		set uri [lindex $url 1]
		if {![string equal [$::documentationTopLevel.html cget -base] $base]} {
			$::documentationTopLevel.html clear
			$::documentationTopLevel.html parse [getHtmlText $base]
			$::documentationTopLevel.html configure -base $base
			set title [getHtmlTitle $::documentationTopLevel.html]
			wm title $::documentationTopLevel $title
			if {[string equal $title {Not Found}]} {
				return
			}
			update
			update idletasks
		}
		$::documentationTopLevel.html yview $uri
		return
	}
	$::documentationTopLevel.html clear
	$::documentationTopLevel.html parse [getHtmlText $url]
	$::documentationTopLevel.html configure -base $url
	wm title $::documentationTopLevel [getHtmlTitle $::documentationTopLevel.html]
	lappend ::visitedUrls $url
}
package require Tkhtml
package require BWidget

proc makeHtmlGui {{top ""}} {
	if {[string length $top] > 0} {
		if {![winfo exists $top]} {
			toplevel $top
			wm protocol $top WM_DELETE_WINDOW [list wm withdraw $top]
			button $top.back -text Back -command [list goBack]
			pack $top.back -side top

			ScrolledWindow $top.sw
			html $top.html -hyperlinkcommand showDocumentation
			$top.sw setwidget $top.html
			pack $top.sw -expand 1 -fill both -side top
			bind HtmlClip <1> {
				set parent [winfo parent %W]
				set url [$parent href %x %y]
				if {[string length $url]} {
					eval [$parent cget -hyperlinkcommand] $url
				}
			}
			bind HtmlClip <Button-4> {
				%W yview scroll -5 units
			}
			bind HtmlClip <Button-5> {
				%W yview scroll 5 units
			}
		}
		puts stderr "wm deiconify $top"
		puts stderr "raise $top"
		wm deiconify $top
		raise $top
		puts stderr "wm deiconify $top"
		puts stderr "raise $top"
	}
}
set documentationTopLevel .documentation
if {![file exists docs.zip]} {
	proc showDocumentation {{url ""}} {
		tk_messageBox -icon info -type ok \
			-parent . -title "No documenation available" \
			-message "No documentation available: You have to download it from \nthe tcluno project page at sourceforge.net"
		return
	}
	return
}
#makeHtmlGui $documentationTopLevel
set ::rootDocument com/module-ix.html
set ::urlRoot docs.zip/docs
package require zipvfs
vfs::zip::Mount $script_path/docs.zip docs.zip
#showDocumentation $::rootDocument
